package org.xtext.example.mydsl.generator;

import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.generator.IGenerator;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.eclipse.xtext.xbase.lib.StringExtensions;
import org.xtext.example.mydsl.myDsl.Greeting;
import org.xtext.example.mydsl.myDsl.VName;

@SuppressWarnings("all")
public class MyDslGenerator implements IGenerator {
  public void doGenerate(final Resource resource, final IFileSystemAccess fsa) {
    TreeIterator<EObject> _allContents = resource.getAllContents();
    Iterable<EObject> _iterable = IteratorExtensions.<EObject>toIterable(_allContents);
    Iterable<Greeting> _filter = IterableExtensions.<Greeting>filter(_iterable, org.xtext.example.mydsl.myDsl.Greeting.class);
    for (final Greeting e : _filter) {
      VName _outname = e.getOutname();
      String _intname = _outname.getIntname();
      String _operator_plus = StringExtensions.operator_plus(_intname, ".out");
      CharSequence _compile = this.compile(e);
      fsa.generateFile(_operator_plus, _compile);
    }
  }
  
  public CharSequence compile(final Greeting p) {
    StringConcatenation _builder = new StringConcatenation();
    VName _outname = p.getOutname();
    _builder.append(_outname, "");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    return _builder;
  }
}
