package org.xtext.example.mydsl.generator;

import org.eclipse.emf.codegen.ecore.genmodel.GenModelPackage;
import org.eclipse.emf.common.util.BasicEMap.Entry;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EcoreFactory;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.xtext.GeneratedMetamodel;
import org.eclipse.xtext.xbase.lib.CollectionExtensions;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xtext.ecoreInference.IXtext2EcorePostProcessor;

@SuppressWarnings("all")
public class MyDslPostProcessor implements IXtext2EcorePostProcessor {
  public void process(final GeneratedMetamodel metamodel) {
    EPackage _ePackage = metamodel.getEPackage();
    this.process(_ePackage);
  }
  
  public void process(final EPackage p) {
    EList<EClassifier> _eClassifiers = p.getEClassifiers();
    Iterable<EClass> _filter = IterableExtensions.<EClass>filter(_eClassifiers, org.eclipse.emf.ecore.EClass.class);
    for (final EClass c : _filter) {
      String _name = c.getName();
      boolean _operator_equals = ObjectExtensions.operator_equals(_name, "VName");
      if (_operator_equals) {
        this.handle(c);
      }
    }
  }
  
  public boolean handle(final EClass c) {
    boolean _xblockexpression = false;
    {
      EOperation _createEOperation = EcoreFactory.eINSTANCE.createEOperation();
      final EOperation op = _createEOperation;
      op.setName("toString");
      EDataType _eString = EcorePackage.eINSTANCE.getEString();
      op.setEType(_eString);
      EAnnotation _createEAnnotation = EcoreFactory.eINSTANCE.createEAnnotation();
      final EAnnotation body = _createEAnnotation;
      body.setSource(GenModelPackage.eNS_URI);
      EClass _eStringToStringMapEntry = EcorePackage.eINSTANCE.getEStringToStringMapEntry();
      EObject _create = EcoreFactory.eINSTANCE.create(_eStringToStringMapEntry);
      final Entry<String,String> map = ((Entry<String,String>) _create);
      map.setKey("body");
      map.setValue("return ToString.valueOf(this);");
      EMap<String,String> _details = body.getDetails();
      _details.add(map);
      EList<EAnnotation> _eAnnotations = op.getEAnnotations();
      CollectionExtensions.<EAnnotation>operator_add(_eAnnotations, body);
      EList<EOperation> _eOperations = c.getEOperations();
      boolean _operator_add = CollectionExtensions.<EOperation>operator_add(_eOperations, op);
      _xblockexpression = (_operator_add);
    }
    return _xblockexpression;
  }
}
